<template>
    <div
        :class="
            first
                ? 'tab-pane table-responsive active'
                : 'tab-pane table-responsive'
        "
        :id="'rate' + clave"
    >
        <table class="table m-b-0 table-hover">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>{{ field.membership }}</th>
                    <th>{{ field.price }}</th>
                    <th>{{ field.action }}</th>
                </tr>
            </thead>
            <tbody v-if="m.length > 0">
                <tr v-for="mem of m" :key="mem.id">
                    <template v-if="editar != mem.id">
                        <td>
                            <span class="list-name"
                                >AC-ME
                                {{
                                    mem.id < 10
                                        ? "000" + mem.id
                                        : mem.id < 100
                                        ? "00" + mem.id
                                        : mem.id < 1000
                                        ? "0" + mem.id
                                        : mem.id
                                }}</span
                            >
                        </td>
                        <td>{{ mem.title }}</td>
                        <td>{{ mem.price }} USD</td>

                        <td>
                            <button
                                @click.prevent="editar = mem.id"
                                class="btn btn-primary btn-small"
                            >
                                {{ field.edit }}
                            </button>
                            <button
                                @click.prevent="eliminar(mem.id)"
                                class="btn btn-danger btn-small"
                            >
                                {{ field.delete }}
                            </button>
                        </td>
                    </template>
                    <template v-if="editar == mem.id">
                        <img
                            v-if="noshow != mem.id"
                            :src="mem.feature_image"
                            alt=""
                            class="img-fluid"
                        />
                        <button
                            v-if="noshow != mem.id"
                            @click.prevent="noshow = mem.id"
                            class="btn btn-primary btn-sm"
                        >
                            {{field.edition
                                            ? field.edition.edit_image
                                            : ''}}
                        </button>
                        <div v-if="noshow == mem.id" class="form-group">
                            <input
                                @change="subir($event,mem.id)"
                                accept=".jpg,.png"
                                type="file"
                                class="form-control"
                            />
                        </div>
                        <div style="width: 300px" :id="'EditarImagen'+mem.id"></div>
                    </template>
                    <template v-if="editar == mem.id">
                        <td v-show="editor" style="width: 200px">
                            <canvas :id="'previewImagen'+mem.id" class="img-responsive"></canvas>
                        </td>
                        <td style="width: 0px"></td>
                        <td style="min-width: 400px;">
                            <div class="form-group">
                                <input @change.prevent="cambio" v-model="mem.feature_image" type="hidden" :id="'Code64'+mem.id">
                                <label for="title">{{
                                    field.edition ? field.edition.title : ""
                                }}</label>
                                <input
                                    name="title"
                                    v-model="mem.title"
                                    type="text"
                                    class="form-control"
                                    :placeholder="
                                        field.edition ? field.edition.title : ''
                                    "
                                />
                            </div>
                            <div class="form-gruop">
                                <label for="price">{{
                                    field.edition ? field.edition.price : ""
                                }}</label>
                                <input
                                    name="price"
                                    v-model="mem.price"
                                    type="number"
                                    class="form-control"
                                    :placeholder="
                                        field.edition ? field.edition.price : ''
                                    "
                                />
                            </div>
                            <div class="form-group">
                                <label for="description">{{
                                    field.edition
                                        ? field.edition.description
                                        : ""
                                }}</label>
                                <textarea
                                    name="description"
                                    v-model="mem.description"
                                    rows="4"
                                    class="form-control"
                                    :placeholder="
                                        field.edition
                                            ? field.edition.description
                                            : ''
                                    "
                                ></textarea>
                            </div>
                        </td>
                        <td>
                            <button
                                @click.prevent="update(mem)"
                                class="btn btn-success btn-small"
                            >
                                {{ field.edition
                                            ? field.edition.save
                                            : '' }}
                            </button>
                            <br>
                            <button
                                @click.prevent="editar = null"
                                class="btn btn-warning btn-small"
                            >
                                {{ field.edition
                                            ? field.edition.cancel
                                            : '' }}
                            </button>
                        </td>
                    </template>
                </tr>
            </tbody>
            <tbody v-if="m.length == 0">
                {{
                    field.empty
                }}
            </tbody>
        </table>
    </div>
</template>
<script>
export default {
    props: ["lang", "clave", "active", "member"],
    mounted() {},
    data() {
        return {
            first: this.active,
            field: this.lang.datatable,
            m: this.member,
            key: this.key,
            editar: null,
            noshow: null,
            editor: null
        };
    },
    methods: {
        subir(e,id){
            let file = e.target.files[0];
            let editor = document.getElementById('EditarImagen'+id);
            const miCanvas = document.querySelector("#previewImagen"+id);
            const contexto = miCanvas.getContext("2d");
            let urlImage = undefined;

            if(e.target.files[0]){
                urlImage = URL.createObjectURL(e.target.files[0]);
                editor.innerHTML = '';
                let cropprImg = document.createElement("img");
                cropprImg.setAttribute("id", "croppr"+id);
                editor.appendChild(cropprImg);
                
                contexto.clearRect(0, 0, miCanvas.width, miCanvas.height);
                document.querySelector("#croppr"+id).setAttribute("src", urlImage);
                new Croppr("#croppr"+id, {
                    aspectRatio: 1,
                    startSize: [70, 70],
                    onCropEnd: recortarImagen
                });

            }
            function recortarImagen(data){
            // Variables
                const inicioX = data.x;
                const inicioY = data.y;
                const nuevoAncho = data.width;
                const nuevaAltura = data.height;
                const zoom = 1;
                let imagenEn64 = "";
                // La imprimo
                miCanvas.width = nuevoAncho;
                miCanvas.height = nuevaAltura;
                // La declaro
                let miNuevaImagenTemp = new Image();
                // Cuando la imagen se carge se procederá al recorte
                miNuevaImagenTemp.onload = function() {
                    // Se recorta
                    contexto.drawImage(
                        miNuevaImagenTemp,
                        inicioX,
                        inicioY,
                        nuevoAncho * zoom,
                        nuevaAltura * zoom,
                        0,
                        0,
                        nuevoAncho,
                        nuevaAltura
                    );
                    // Se transforma a base64
                    imagenEn64 = miCanvas.toDataURL("image/jpeg");
                    let el =document.getElementById('Code64'+id);
                    el.value = imagenEn64;
                    el.dispatchEvent(new Event('input'))
                };
                miNuevaImagenTemp.src = urlImage;
            }
            
        },
        update(m){
            console.log(m);
            axios.put('/api/memberships/'+m.id,m).then(res => {
                this.editar = null
            }).catch(err => {
                console.log(err);
            })
        },
        eliminar(id){
            axios.delete('/api/memberships/'+id,{data:{status:false}}).then(res => {
                location.reload();
            })
        }
        
    }
};
</script>
<style>
canvas {
  width: 100%;
  height: auto;
}
</style>
